let container = document.getElementById("create");
let keyContainer = document.getElementById("key");
let initializeButton = document.querySelector("div.initialize > button");
let key = keyContainer.dataset.key;

let characters = ["a", "b", "c", "d", "e", "f", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"];

container.dataset.state = "initialize";
keyContainer.parentNode.querySelector("button.button").classList.add("disabled");

let runtime = 5000; // Runtime in milliseconds
let starttime = Date.now();

initializeButton.addEventListener("click", () => {
    starttime = Date.now();
    container.dataset.state = "processing";
    generateRandomKey(0);
    let interval = setInterval(() => {
        if ((starttime + runtime) < Date.now()) {
            clearInterval(interval);
            container.dataset.state = "finished";
            keyContainer.parentNode.querySelector("button.button").classList.remove("disabled");
        }
        let steps = runtime / 32;
        let skipped_characters = Math.ceil((Date.now() - starttime) / steps);
        generateRandomKey(skipped_characters);
    }, 100);
});

function generateRandomKey(skip) {
    let random_key = "";
    if (!skip) {
        skip = 0;
    } else {
        skip = Math.max(Math.min(32, skip), 0);
    }
    for (let i = 0; i < 32; i++) {
        let character = "";
        if (i == 8 || i == 12 || i == 16 || i == 20) {
            random_key += "-";
        }
        character = characters[Math.floor(Math.random() * characters.length)];
        if (skip > i) {
            character = key.replaceAll("-", "").charAt(i);
        }
        random_key += character;
    }
    keyContainer.value = random_key;
}